/usr/bin/cvs-upgrade is in cvs-buildpackage 5.23.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 | #! /bin/bash
# -*- Mode: Sh -*-
# cvs-upgrade ---
# Author : Manoj Srivastava ( srivasta@tiamat.datasync.com )
# Created On : Fri Feb 20 15:17:09 1998
# Created On Node : tiamat.datasync.com
# Last Modified By : Manoj Srivastava
# Last Modified On : Tue Aug 26 03:01:22 2003
# Last Machine Used: glaurung.green-gryphon.com
# Update Count : 102
# Status : Unknown, Use with caution!
# HISTORY :
# Description :
#
#
# Make sure we abort on error
set -e
declare -a argv
progname="`basename \"$0\"`"
pversion='$Revision: 1.35 $'
setq() {
# Variable Value Doc string
if [ "x$2" = "x" ]; then
echo >&2 "$progname: Unable to determine $3"
exit 1;
else
if [ ! "x$Verbose" = "x" ]; then
echo "$progname: $3 is $2";
fi
eval "$1=\"\$2\"";
fi
}
withecho () {
echo " $@" >&2
"$@"
}
usageversion () {
cat >&2 <<END
Usage: $progname [options] <package name> <upstream version> <debian version>
Options:
-h print this message
-F Force removal of CVS directories and symbolic links
before import. This should be used with caution!!
-m Add a cvs message based on the changelog
-M<module> CVS module name
-R<root dir> Root directory.
-T<tag> CVS Tag to use
-U<tag> Upstream tag to use
-W<work dir> Working directory.
-d<digit> Set Debug Level
-n "Dry-run" mode - No action taken, only print commands.
-v make the command verbose
-ctp Include <package>_ at start of CVS tag.
-x<prefix> CVS default module prefix.
Files are unpacked in here while being upgraded. The new upstream
sources are expected in the file
<workdir>/<package name>/<package name>_<upstream version>.orig.tar.gz)
and should unpack into a subdir.
Note that the current behaviour of cvs-upgrade is to ignore files that
match the default list of file name patterns to be ignored (this is
built into cvs); and that any .cvsignore files in the upstream sources
shall be honoured.
END
}
# The defaults
docmd='YES'
action='withecho'
tmpdir="temp-$progname"
DEBUG=0
VERBOSE=0
# parse Command line
# Note that we use `"$@"' to let each command-line parameter expand to a
# separate word. The quotes around `$@' are essential!
# We need TEMP as the `eval set --' would nuke the return value of getopt.
TEMP=$(getopt -a -s bash -o hFmM:R:T:U:W:ncd:x:v --long ctp,help \
-n 'cvs-upgrade' -- "$@")
if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
# Note the quotes around `$TEMP': they are essential!
eval set -- "$TEMP"
while true ; do
case "$1" in
-h|--help) usageversion; exit 0 ; shift ;;
-F) opt_forceclean=1 ; shift ;;
-m) opt_use_changelog=1 ; shift ;;
-M) opt_cvsmodule="$2" ; shift 2 ;;
-R) opt_rootdir="$2" ; shift 2 ;;
-T) opt_tag="$2" ; shift 2 ;;
-U) opt_utag="$2" ; shift 2 ;;
-W) opt_workdir="$2" ; shift 2 ;;
-n) action='echo';docmd='NO' ; shift ;;
-v) VERBOSE=1 ; shift ;;
-d) opt_DEBUG="$2" ; shift 2 ;;
-x) opt_prefix="$2" ; shift 2 ;;
-c|--ctp) opt_packageintag=1 ; shift ;;
--) shift ; break ;;
*) echo >&2 "Internal error!($i)"
usageversion; exit 1 ;;
esac
done
# We need at lease two arguments
if [ $# -lt 2 ]; then
echo >&2 " Require package name and upstream version"
usageversion;
exit 1;
fi
package=$1
shift
upstream_version=$1
if [ "X$opt_utag" != "X" ]; then
cvs_upstream_tag="$opt_utag"
else
cvs_upstream_tag=$(echo -n "upstream_version_${upstream_version}" |\
tr -c -- "-_a-zA-Z0-9" "_" )
fi
shift
if [ $# != 0 ]; then
debian_version=$1
if [ "x$opt_tag" != "x" ]; then
cvstag="$opt_tag"
else
cvstag=$(echo -n "debian_version_${upstream_version}-${debian_version}" |\
tr -c -- "-_a-zA-Z0-9" "_" )
fi
else
debian_version=""
if [ "x$opt_tag" != "x" ]; then
cvstag="$opt_tag"
else
cvstag=$(echo -n "debian_version_${upstream_version}" | \
tr -c -- "-_a-zA-Z0-9" "_")
fi
fi
CVS_QUIET="-Q"
TAR_QUIET=""
if [ $VERBOSE -gt 0 ]; then
echo " *** Initializing ... ***"
fi
if [ "X$CVSROOT" = "X" ]; then
echo "You should have set the CVSROOT env variable." 1>&2
usageversion;
exit 1
fi
# get the package name
rootdir='/usr/local/src/Packages'
# Load site defaults and over rides.
if [ -f /etc/cvsdeb.conf ]; then
. /etc/cvsdeb.conf
fi
# Load user defaults and over rides.
if [ -f ~/.cvsdeb.conf ]; then
. ~/.cvsdeb.conf
fi
# If asked to debug on command line, that's what we get
if [ ! "x$opt_DEBUG" = "x" ]; then
DEBUG="$opt_DEBUG"
fi
if [ "$DEBUG" -gt 0 ]; then
CVS_QUIET=""
TAR_QUIET="vv"
fi
# Command line, env variable, config file, or default
if [ ! "x$opt_rootdir" = "x" ]; then
rootdir="$opt_rootdir"
elif [ ! "x$CVSDEB_ROOTDIR" = "x" ]; then
rootdir="$CVSDEB_ROOTDIR"
elif [ ! "x$conf_rootdir" = "x" ]; then
rootdir="$conf_rootdir"
fi
# Command line, env variable, config file, or default
if [ ! "x$opt_workdir" = "x" ]; then
workdir="$opt_workdir"
elif [ ! "x$CVSDEB_WORKDIR" = "x" ]; then
workdir="$CVSDEB_WORKDIR"
elif [ ! "x$conf_workdir" = "x" ]; then
workdir="$conf_workdir"
else
workdir="$rootdir/$package"
fi
# Command line, env variable, config file, or default
if [ ! "x$opt_forceclean" = "x" ]; then
forceclean="$opt_forceclean"
elif [ ! "x$CVSDEB_FORCECLEAN" = "x" ]; then
forcecelan="$CVSDEB_FORCECLEAN"
elif [ ! "x$conf_forceclean" = "x" ]; then
forceclean="$conf_forceclean"
else
forceclean=""
fi
# Command line, env variable, config file, or default
if [ ! "x$opt_prefix" = "x" ]; then
prefix="$opt_prefix"
elif [ ! "x$CVSDEB_PREFIX" = "x" ]; then
prefix="$CVSDEB_PREFIX"
elif [ ! "x$conf_prefix" = "x" ]; then
prefix="$conf_prefix"
else
prefix=""
fi
# put a slash at the end of the prefix
if [ "X$prefix" != "X" ]; then
prefix="$prefix/";
prefix=`echo $prefix | sed 's://:/:g'`;
fi
# Command line, env variable, or default
if [ ! "x$opt_cvsmodule" = "x" ]; then
cvsmodule="$opt_cvsmodule"
elif [ ! "x$CVSDEB_MODULE" = "x" ]; then
cvsmodule="$CVSDEB_MODULE"
else
cvsmodule="${prefix}$package"
fi
# Command line, env variable, config file, or default
if [ ! "x$opt_packageintag" = "x" ]; then
packageintag="$opt_packageintag"
elif [ ! "x$CVSDEB_PACKAGEINTAG" = "x" ]; then
packageintag="$CVSDEB_PACKAGEINTAG"
elif [ ! "x$conf_packageintag" = "x" ]; then
packageintag="$conf_packageintag"
else
packageintag=""
fi
if [ "x$packageintag" != x ]; then
cvstag=$(echo -n "${package}_$cvstag"|tr -c -- "-_a-zA-Z0-9" "_")
cvs_upstream_tag=$(echo -n "${package}_$cvs_upstream_tag"| \
tr -c -- "-_a-zA-Z0-9" "_")
fi
# Command line, env variable, config file, or default
if [ ! "x$opt_use_changelog" = "x" ]; then
use_changelog="$opt_use_changelog"
elif [ ! "x$CVSDEB_USE_CHANGELOG" = "x" ]; then
use_changelog="$CVSDEB_USE_CHANGELOG"
elif [ ! "x$conf_use_changelog" = "x" ]; then
use_changelog="$conf_use_changelog"
else
use_changelog=""
fi
# env variable, or default
if [ ! "x$CVSDEB_IMPORTSUBSTMODE" = "x" ]; then
importsubstmode="$CVSDEB_IMPORTSUBSTMODE"
else
importsubstmode="-ko -d"
fi
# No user defined changes here
pkgdir="$workdir/$package-$upstream_version"
orig_tarfile="$workdir/${package}_${upstream_version}.orig.tar.gz"
if [ ! -r $orig_tarfile ]; then
echo >&2 "I could not find the expected file $orig_tarfile"
echo >&2 "I parsed the package name=($package), version=${upstream_version}"
if [ $debian_version ]; then
echo >&2 "The debian revision seems to be $debian_version"
else
echo >&2 "This seems to be a debian only package"
fi
echo >&2 "The working directory is $workdir"
echo >&2 ""
echo >&2 "Since something has gone wrong, I am aborting"
exit 1
fi
echo " "
echo "######################## Note ######################## "
echo " "
echo "# Please remember to incorporate the changes made upstream. "
echo "# If you do not have a working directory, you may simply do the "
echo "# following manually: "
#echo " cvs co -jsource-dist:yesterday -jsource-dist:today ${cvsmodule} "
#echo "# or "
echo " cvs co -jupstream_version_<OLD-VERSION> -j$cvs_upstream_tag ${cvsmodule}"
echo " "
echo "# If you already have a checked out working directory, please do: "
echo " cd ${cvsmodule} "
#echo " cvs update -d -jsource-dist:yesterday -jsource-dist:today "
#echo "# or "
echo " cvs update -d -jupstream_version_<OLD-VERSION> -j$cvs_upstream_tag "
echo " "
#echo "# If you have not already done so, you should also run cvs-co-upgrade "
#echo "# to see if you need to do anything about files that have been "
#echo "# deleted in upstream sources "
#echo "cvs-co-upgrade ${package} <OLD-VERSION> $upstream_version "
#echo " "
echo "# After that don't forget to commit and tag your newly created "
echo "# revision as "
echo " "
echo " cd ${cvsmodule} "
echo " edit debian/changelog "
echo " cvs ci -m'New upstream source' "
echo " cvs $CVS_QUIET tag -d ${cvstag} "
echo " cvs $CVS_QUIET tag -F ${cvstag} "
echo " cd ${workdir} "
echo " rm -rf ${cvsmodule} "
echo " "
echo "############## Starting automated tasks ############## "
echo " "
if [ $VERBOSE -gt 0 ]; then
echo ""
echo " *** Preparing the working directory *** "
fi
if [ ! -d "$workdir" ]; then
$action mkdir -p "$workdir"
fi
$action cd "$workdir"
$action mkdir "${tmpdir}"
if [ "X$docmd" = "XYES" ]; then
if [ ! -d "${tmpdir}" ]; then
echo >&2 "The working directory ($workdir) is not writable"
exit 1
fi
fi
if [ $VERBOSE -gt 0 ]; then
echo ""
echo " *** Unpacking the new sources *** "
fi
eval "$action cd ${tmpdir}"
eval "$action tar ${TAR_QUIET}zfx ../${package}_${upstream_version}.orig.tar.gz"
if [ "X$docmd" = "XYES" ]; then
numdirs=`ls -1 | wc -l`
if [ ${numdirs} -gt 1 ]; then
echo >&2 "Source unpacked into more than one dir"
cd ..
mkdir "${tmpdir}-new"
mv "${tmpdir}" "${tmpdir}-new/${package}-${upstream_version}"
mv "${tmpdir}-new" "${tmpdir}"
cd "${tmpdir}"
fi
$action cd `ls -1`
else
echo "numdirs=\`ls -1 | wc -l\`"
echo "if [ \$numdirs -gt 1 ]; then "
echo " echo >&2 Source unpacked into more than one dir"
echo " cd .."
echo " mkdir ${tmpdir}-new"
echo " mv ${tmpdir} ${tmpdir}-new/${package}-${upstream_version}"
echo " mv ${tmpdir}-new ${tmpdir}"
echo " cd ${tmpdir}"
echo "fi"
echo "cd \`ls -1\`"
fi
clean_up() {
if [ $VERBOSE -gt 0 ]; then
echo ""
echo "# Cleaning up"
fi
$action cd "${workdir}"
if [ "X$docmd" = "XYES" ]; then
if [ -d "${tmpdir}" ]; then
$action rm -rf "${tmpdir}"
if [ -d "${tmpdir}" ]; then
echo "Hmm. Something went wrong trying to remove the temp dir"
echo "Retrying."
$action chmod -r u+w "${tmpdir}"
$action rm -rf "${tmpdir}"
fi
fi
else
$action rm -rf "${tmpdir}"
fi
}
# check for symbolic links in the upstream sources
check_symlinks() {
symbolic_links=$(find . -type l -print)
if [ "X$symbolic_links" != "X" ]; then
if [ "X$forceclean" != "X" ]; then
echo >&2 "You have asked me to remove symbolic links I find."
echo >&2 "since cvs import chokes on them. I have found"
echo >&2 "the following symbolic links:"
echo >&2 "$symbolic_links"
echo >&2 ""
ans=""
while [ "X$ans" = "X" ]; do
echo -n >&2 "Shall I remove the links?[y/n]"
read ans;
case $ans in
y*|Y*)
$action rm -f $symbolic_links
;;
*)
echo >&2 "Please delete the following"
echo >&2 "links and try again."
echo >&2 "$symbolic_links"
clean_up;
exit 1
esac
done
else
echo >&2 "The upstream sources contain symbolic links."
echo >&2 "CVS ignores symblic links, you have to handle link "
echo >&2 "creation in the modules file (-e and -o args)"
echo >&2 "Since this causes an error on import, I can't."
echo >&2 "handle this. Please delete the following"
echo >&2 "links and try again."
echo >&2 "$symbolic_links"
clean_up;
exit 1
fi
fi
}
check_CVS_dirs() {
CVS_dirs=$(find . -type d -name CVS -print)
if [ "X$CVS_dirs" != "X" ]; then
if [ "X$forceclean" != "X" ]; then
echo >&2 "You have asked me to remove CVS dirs I find."
echo >&2 "since cvs import chokes on them. I have found"
echo >&2 "the following dirs:"
echo >&2 "$CVS_dirs"
echo >&2 ""
ans=""
while [ "X$ans" = "X" ]; do
echo -n >&2 "Shall I remove the Directories?[y/n]"
read ans;
case $ans in
y*|Y*)
$action rm -rf $CVS_dirs
;;
*)
echo >&2 "Please delete the following"
echo >&2 "CVS directories and try again."
echo >&2 "$CVS_dirs"
clean_up;
exit 1
esac
done
else
echo >&2 "The upstream sources contain CVS directories."
echo >&2 "This I can't handle. Please delete the following"
echo >&2 "directories and try again."
echo >&2 "$CVS_dirs"
clean_up;
exit 1
fi
fi
}
check_CVS_ignore() {
CVS_ignores=$(find . -type f -name .cvsignore -print)
if [ "X$CVS_ignores" != "X" ]; then
if [ "X$forceclean" != "X" ]; then
echo >&2 "You have asked me to remove .cvsignore I find."
echo >&2 "since cvs import may be adversly affected.. "
echo >&2 "I have found the following dirfiles:"
echo >&2 "$CVS_ignores"
echo >&2 ""
ans=""
while [ "X$ans" = "X" ]; do
echo -n >&2 "Shall I remove the files?[y/n]"
read ans;
case $ans in
y*|Y*)
$action rm -f $CVS_ignores
;;
*)
echo >&2 "Please delete the following"
echo >&2 "CVS .ignore files and try again."
echo >&2 "$CVS_ignores"
clean_up;
exit 1
esac
done
fi
fi
}
if [ "X$docmd" = "XYES" ]; then
check_symlinks;
check_CVS_dirs;
check_CVS_ignore;
fi
if [ $VERBOSE -gt 0 ]; then
echo ""
echo " *** Importing the new sources *** "
fi
if [ ! "X$use_changelog" = "X" -a -f debian/changelog ]; then
changes=`dpkg-parsechangelog | grep '^ '`
fi
argv=(cvs $CVS_QUIET import ${importsubstmode} -m"Imported upstream version $upstream_version. $changes" "${cvsmodule}" source-dist "${cvs_upstream_tag}")
$action "${argv[@]}"
$action cd ../..
$action rm -rf "${tmpdir}"
if [ -d "${tmpdir}" ]; then
echo "Hmm. Somethiung went wrong trying to remove the temp dir"
echo "Retrying."
$action chmod -R u+w "${tmpdir}"
$action rm -rf "${tmpdir}"
fi
#echo "#Don't forget cvs-co-upgrade $cvsmodule <OLD-VERSION> $upstream_version"
exit 0
|